Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90	(revision 5075)
@@ -950,8 +937,8 @@
 
          ! look for variable id
-         il_ind(:)=MINLOC(td_file%t_var(:)%i_id,mask=(td_file%t_var(:)%i_id==id_varid))
-         IF( il_ind(1) /= 0 )THEN
-
-            iom_rstdimg__read_var_id=td_file%t_var(il_ind(1))
+         il_varid(:)=MINLOC(td_file%t_var(:)%i_id,mask=(td_file%t_var(:)%i_id==id_varid))
+         IF( il_varid(1) /= 0 )THEN
+
+            iom_rstdimg__read_var_id=var_copy(td_file%t_var(il_varid(1)))
 
             IF( iom_rstdimg__read_var_id%i_ndim /= 0 )THEN
@@ -962,5 +949,5 @@
             ELSE
                CALL logger_debug( " READ VAR: variable 0d "//&
-               &               TRIM(td_file%t_var(il_ind(1))%c_name)//&
+               &               TRIM(td_file%t_var(il_varid(1))%c_name)//&
                &               " should be already read ")
             ENDIF            
@@ -974,27 +961,24 @@
       ENDIF
    END FUNCTION iom_rstdimg__read_var_id
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable value in an opened 
-   !> dimg file, given variable name or standard name.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
+   !> dimg file, given variable name or standard name.
    !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !
    !> look first for variable name. If it doesn't
    !> exist in file, look for variable standard name.<br/>
-   !> If variable name is not present, check variable standard name.<br/>
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] cd_name  : variable name or standard name 
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] cd_name   variable name or standard name 
+   !> @param[in] id_start  index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_rstdimg__read_var_name(td_file, cd_name,   &
    &                                              id_start, id_count  )
@@ -1005,9 +989,7 @@
       INTEGER(i4),      DIMENSION(:),  INTENT(IN), OPTIONAL :: id_start
       INTEGER(i4),      DIMENSION(:),  INTENT(IN), OPTIONAL :: id_count
-      !INTEGER(i4),      DIMENSION(ip_maxdim),  INTENT(IN), OPTIONAL :: id_start
-      !INTEGER(i4),      DIMENSION(ip_maxdim),  INTENT(IN), OPTIONAL :: id_count
 
       ! local variable
-      INTEGER(i4)       :: il_ind
+      INTEGER(i4)       :: il_varid
       !----------------------------------------------------------------
       ! check if file opened
@@ -1019,10 +1001,10 @@
       ELSE
 
-         il_ind=var_get_id(td_file%t_var(:), cd_name)
-         IF( il_ind /= 0 )THEN
-
-            iom_rstdimg__read_var_name=td_file%t_var(il_ind)
-
-            IF( td_file%t_var(il_ind)%i_ndim /= 0 )THEN
+         il_varid=var_get_index(td_file%t_var(:), cd_name)
+         IF( il_varid /= 0 )THEN
+
+            iom_rstdimg__read_var_name=var_copy(td_file%t_var(il_varid))
+
+            IF( td_file%t_var(il_varid)%i_ndim /= 0 )THEN
                !!! read variable value
                CALL iom_rstdimg__read_var_value( td_file, &
@@ -1031,5 +1013,5 @@
             ELSE
                CALL logger_debug( " READ VAR: variable 0d "//&
-               &               TRIM(td_file%t_var(il_ind)%c_name)//&
+               &               TRIM(td_file%t_var(il_varid)%c_name)//&
                &               " should have been already read ")
             ENDIF
@@ -1047,197 +1029,19 @@
       
    END FUNCTION iom_rstdimg__read_var_name
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill all variable value in an opened 
-   !> dimg file.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_rstdimg__fill_var_all(td_file, id_start, id_count)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TFILE),               INTENT(INOUT) :: td_file
-      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_start
-      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_count
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL :: id_start
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL :: id_count
-
-      ! local variable
-
-      ! loop indices
-      INTEGER(i4) :: ji
-      !----------------------------------------------------------------
-      ! check if file opened
-      IF( td_file%i_id == 0 )THEN
-
-         CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
-
-      ELSE
-
-         DO ji=1,td_file%i_nvar
-            CALL iom_rstdimg_fill_var(td_file, ji, id_start, id_count)
-         ENDDO
-
-      ENDIF
-   END SUBROUTINE iom_rstdimg__fill_var_all
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill variable value in an opened 
-   !> dimg file, given variable id.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_rstdimg__fill_var_id(td_file, id_varid, id_start, id_count)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TFILE),               INTENT(INOUT) :: td_file
-      INTEGER(i4),               INTENT(IN)    :: id_varid
-      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_start
-      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_count
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL :: id_start
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL :: id_count
-
-      ! local variable
-      INTEGER(i4), DIMENSION(1) :: il_ind
-      TYPE(TVAR)                :: tl_var
-      !----------------------------------------------------------------
-      ! check if file opened
-      IF( td_file%i_id == 0 )THEN
-
-         CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
-
-      ELSE
-
-         ! look for variable id
-         il_ind(:) = MINLOC( td_file%t_var(:)%i_id, &
-         &                   mask=(td_file%t_var(:)%i_id==id_varid))
-         IF( il_ind(1) /= 0 )THEN
-
-            IF( tl_var%i_ndim /= 0 )THEN
-               !!! read variable value
-               CALL iom_rstdimg__read_var_value(td_file, td_file%t_var(il_ind(1)), &
-               &                                id_start, id_count)
-
-            ELSE
-               CALL logger_debug( " FILL VAR: variable 0d "//&
-               &               TRIM(td_file%t_var(il_ind(1))%c_name)//&
-               &               " should be already read ")
-            ENDIF            
-
-         ELSE
-            CALL logger_error( &
-            &  " FILL VAR: there is no variable with id "//&
-            &  TRIM(fct_str(id_varid))//" in file "//TRIM(td_file%c_name))
-         ENDIF
-
-      ENDIF
-   END SUBROUTINE iom_rstdimg__fill_var_id
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill variable value in an opened 
-   !> dimg file, given variable name or standard name.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @details
-   !> look first for variable name. If it doesn't
-   !> exist in file, look for variable standard name.<br/>
-   !> If variable name is not present, check variable standard name.<br/>
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name  : variable name or standard name
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @return  variable structure 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_rstdimg__fill_var_name(td_file, cd_name, id_start, id_count )
-      IMPLICIT NONE
-      ! Argument 
-      TYPE(TFILE),                    INTENT(INOUT) :: td_file
-      CHARACTER(LEN=*),               INTENT(IN)    :: cd_name
-      INTEGER(i4),      DIMENSION(:), INTENT(IN), OPTIONAL :: id_start
-      INTEGER(i4),      DIMENSION(:), INTENT(IN), OPTIONAL :: id_count
-      !INTEGER(i4),      DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_start
-      !INTEGER(i4),      DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_count
-      !CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
-
-      ! local variable
-      INTEGER(i4)       :: il_ind
-      !----------------------------------------------------------------
-      ! check if file opened
-      IF( td_file%i_id == 0 )THEN
-
-         CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
-
-      ELSE
-
-         il_ind=var_get_id(td_file%t_var, cd_name)
-         IF( il_ind /= 0 )THEN
-
-            IF( td_file%t_var(il_ind)%i_ndim /= 0 )THEN
-               !!! read variable value
-               CALL iom_rstdimg__read_var_value( td_file, td_file%t_var(il_ind), &
-               &                                 id_start, id_count)
-
-            ELSE
-               CALL logger_debug( " FILL VAR: variable 0d "//&
-               &               TRIM(td_file%t_var(il_ind)%c_name)//&
-               &               " should have been already read ")
-            ENDIF
-
-         ELSE
-
-            CALL logger_error( &
-            &  " FILL VAR: there is no variable with "//&
-            &  " name or standard name "//TRIM(cd_name)//&
-            &  " in file "//TRIM(td_file%c_name))
-
-         ENDIF
-
-      ENDIF
-      
-   END SUBROUTINE iom_rstdimg__fill_var_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read variable value in an opened dimg file, for
    !> variable 1,2,3d.
-   !
+   !> @details
+   !> Optionaly,start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] id_start : index in the variable from which the data values will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @return variable structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[inout] td_var variable structure
+   !> @param[in] id_start  index in the variable from which the data values will be read
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__read_var_value(td_file, td_var, &
    &                                      id_start, id_count )
@@ -1248,6 +1052,4 @@
       INTEGER(i4), DIMENSION(:), INTENT(IN),  OPTIONAL :: id_start
       INTEGER(i4), DIMENSION(:), INTENT(IN),  OPTIONAL :: id_count
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),  OPTIONAL :: id_start
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),  OPTIONAL :: id_count
 
       ! local variable
@@ -1273,5 +1075,5 @@
          IF( SIZE(id_start(:)) /= ip_maxdim .OR. &
          &   SIZE(id_count(:)) /= ip_maxdim )THEN
-            CALL logger_error("READ VAR: dimension of table start or count "//&
+            CALL logger_error("READ VAR: dimension of array start or count "//&
             &      " are invalid to read variable "//TRIM(td_var%c_name)//&
             &      " in file "//TRIM(td_file%c_name) )
@@ -1328,5 +1130,5 @@
             &  " READ VAR VALUE: not enough space to put variable "//&
             &  TRIM(td_var%c_name)//&
-            &  " in temporary table")
+            &  " in temporary array")
 
          ENDIF
@@ -1358,5 +1160,5 @@
             ENDIF
          ELSEIF( td_var%t_dim(3)%l_use )THEN
-            ! 1d variable (Z)
+            ! 1D variable (Z)
             READ(td_file%i_id, IOSTAT=il_status, REC=td_var%i_rec ) &
             &  dl_value(:,:,:,:)
@@ -1403,16 +1205,17 @@
 
    END SUBROUTINE iom_rstdimg__read_var_value
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine write file structure in an opened dimg file.
+   !-------------------------------------------------------------------
+   !> @brief This subroutine write dimg file from file structure.
    !
    !> @details
-   !
+   !> dimg file have to be already opened in write mode.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use iom_rstdimg__get_rec
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg_write_file(td_file)
       IMPLICIT NONE
@@ -1421,6 +1224,6 @@
 
       ! local variable
-      INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_attid
+      INTEGER(i4)           :: il_status
+      INTEGER(i4)           :: il_ind
       !----------------------------------------------------------------
       ! check if file opened
@@ -1433,17 +1236,36 @@
          IF( td_file%l_wrt )THEN
 
+            ! check dimension
+            IF( td_file%t_dim(jp_L)%l_use .AND. &
+            &   td_file%t_dim(jp_L)%i_len /= 1 )THEN
+               CALL logger_fatal("WRITE FILE: can not write dimg file with "//&
+               &  " several time step.")
+            ENDIF
+
             ! close and open file with right record length
             CALL iom_rstdimg_close(td_file)
 
+            ! compute record number to be used 
+            ! and add variable no0d, no1d,.. if need be
+            CALL iom_rstdimg__get_rec(td_file)
+
             ! compute record length
-            il_attid=att_get_id(td_file%t_att(:),"DOMAIN_number_total")
-            IF( il_attid /= 0 )THEN
+            il_ind=att_get_index(td_file%t_att(:),"DOMAIN_number_total")
+            IF( il_ind /= 0 )THEN
                td_file%i_recl = MAX( &
                &     td_file%t_dim(1)%i_len * td_file%t_dim(2)%i_len * 8, &
-               &     ( 8 * INT(td_file%t_att(il_attid)%d_value(1)) + 15 ) * 4 )
+               &     ( 8 * INT(td_file%t_att(il_ind)%d_value(1)) + 15 ) * 4 )
             ELSE
                td_file%i_recl = td_file%t_dim(1)%i_len * &
                &                td_file%t_dim(2)%i_len * 8
             ENDIF
+            ! check record length
+            IF( td_file%i_nvar*(im_vnl+dp) > td_file%i_recl )THEN
+               CALL logger_fatal("WRITE FILE: record length is too small. "//&
+               &  " Try to reduce the output number of processor.")
+            ENDIF
+
+            ! get free unit
+            td_file%i_id=fct_getunit()
 
             OPEN( td_file%i_id, FILE=TRIM(td_file%c_name),&
@@ -1456,8 +1278,8 @@
             CALL fct_err(il_status)
             IF( il_status /= 0 )THEN
-               CALL logger_error("REPLACE: file "//TRIM(td_file%c_name)//&
+               CALL logger_error("WRITE FILE: REPLACE file "//TRIM(td_file%c_name)//&
                &  " with record length "//TRIM(fct_str(td_file%i_recl)))
             ELSE
-               CALL logger_debug("REPLACE: file "//TRIM(td_file%c_name)//&
+               CALL logger_debug("WRITE FILE: REPLACE file "//TRIM(td_file%c_name)//&
                &  " with record length "//TRIM(fct_str(td_file%i_recl)))
             ENDIF
@@ -1479,5 +1301,111 @@
 
    END SUBROUTINE iom_rstdimg_write_file
-   !> @endcode
+   !-------------------------------------------------------------------
+   !> @brief This subroutine compute record number to be used.
+   !>
+   !> @details
+   !> Moreover it adds variable no0d, no1d, no2d and no3d if need be.
+   !>
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
+   SUBROUTINE iom_rstdimg__get_rec(td_file)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TFILE), INTENT(INOUT) :: td_file
+
+      ! local variable
+      INTEGER(i4) :: il_rec
+      TYPE(TVAR)  :: tl_var
+
+      INTEGER(i4), DIMENSION(:)    , ALLOCATABLE :: il_tmp1d
+      INTEGER(i4), DIMENSION(:,:)  , ALLOCATABLE :: il_tmp2d
+      INTEGER(i4), DIMENSION(:,:,:), ALLOCATABLE :: il_tmp3d
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      ! add dummy variable if necessary
+      IF( td_file%i_n0d == 0 )THEN
+         ! create var
+         tl_var=var_init('no0d')
+
+         CALL file_add_var( td_file, tl_var )
+      ENDIF
+
+      IF( td_file%i_n1d == 0 )THEN
+         ! create var
+         ALLOCATE( il_tmp1d( td_file%t_dim(3)%i_len ) )
+         il_tmp1d(:)=-1
+
+         tl_var=var_init( 'no1d', il_tmp1d(:)) 
+
+         DEALLOCATE( il_tmp1d )
+
+         CALL file_add_var( td_file, tl_var ) 
+      ENDIF
+ 
+      IF( td_file%i_n2d == 0 )THEN
+         ! create var
+         ALLOCATE( il_tmp2d( td_file%t_dim(1)%i_len, &
+         &                   td_file%t_dim(2)%i_len ) )
+         il_tmp2d(:,:)=-1
+
+         tl_var=var_init('no2d', il_tmp2d(:,:) )
+
+         DEALLOCATE( il_tmp2d )
+
+         CALL file_add_var( td_file, tl_var ) 
+
+      ENDIF
+ 
+      IF( td_file%i_n3d == 0 )THEN
+         ! create var
+         ALLOCATE( il_tmp3d( td_file%t_dim(1)%i_len, &
+         &                   td_file%t_dim(2)%i_len, &
+         &                   td_file%t_dim(3)%i_len ) )
+         il_tmp3d(:,:,:)=-1
+
+         tl_var=var_init('no3d', il_tmp3d(:,:,:) )
+
+         DEALLOCATE( il_tmp3d )
+
+         CALL file_add_var( td_file, tl_var ) 
+      ENDIF
+
+      ! clean
+      CALL var_clean(tl_var)
+
+      il_rec=2
+      DO ji=1,td_file%i_nvar
+         SELECT CASE(td_file%t_var(ji)%i_ndim)
+            CASE(0)
+               IF( INDEX(td_file%t_var(ji)%c_name, 'no0d' ) == 0 )THEN
+                  td_file%t_var(ji)%i_rec=il_rec
+                  il_rec = il_rec  + 0
+               ENDIF
+            CASE(1)
+               IF( INDEX(td_file%t_var(ji)%c_name, 'no1d' ) == 0 )THEN
+                  td_file%t_var(ji)%i_rec=il_rec
+                  il_rec = il_rec  + 1
+               ENDIF
+            CASE(2)
+               IF( INDEX(td_file%t_var(ji)%c_name, 'no2d' ) == 0 )THEN
+                  td_file%t_var(ji)%i_rec=il_rec
+                  il_rec = il_rec  + 1
+               ENDIF
+            CASE(3)
+               IF( INDEX(td_file%t_var(ji)%c_name, 'no3d' ) == 0 )THEN
+                  td_file%t_var(ji)%i_rec=il_rec
+                  il_rec = il_rec  + td_file%t_dim(3)%i_len
+               ENDIF
+         END SELECT
+      ENDDO
+      td_file%i_rhd  = il_rec
+
+      END SUBROUTINE iom_rstdimg__get_rec
    !-------------------------------------------------------------------
    !> @brief This subroutine write header in an opened dimg 
@@ -1485,11 +1413,8 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] td_dim : dimension structure
-   !> @return  dimension id 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__write_header(td_file)
       IMPLICIT NONE
@@ -1499,5 +1424,5 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_attid
+      INTEGER(i4) :: il_ind
       INTEGER(i4) :: il_nproc
       INTEGER(i4) :: il_niproc
@@ -1537,20 +1462,20 @@
 
       ! get domain decomposition
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_number_total" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_number_total" )
       il_nproc = 1
-      IF( il_attid /= 0 )THEN
-         il_nproc = INT(td_file%t_att(il_attid)%d_value(1))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_I_number_total" )
+      IF( il_ind /= 0 )THEN
+         il_nproc = INT(td_file%t_att(il_ind)%d_value(1))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_I_number_total" )
       il_niproc = 0
-      IF( il_attid /= 0 )THEN
-         il_niproc = INT(td_file%t_att(il_attid)%d_value(1))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_J_number_total" )
+      IF( il_ind /= 0 )THEN
+         il_niproc = INT(td_file%t_att(il_ind)%d_value(1))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_J_number_total" )
       il_njproc = 0
-      IF( il_attid /= 0 )THEN
-         il_njproc = INT(td_file%t_att(il_attid)%d_value(1))
+      IF( il_ind /= 0 )THEN
+         il_njproc = INT(td_file%t_att(il_ind)%d_value(1))
       ENDIF
 
@@ -1570,17 +1495,17 @@
       
       ! get domain number
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_number" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_number" )
       il_area = 0
-      IF( il_attid /= 0 )THEN
-         il_area = INT(td_file%t_att(il_attid)%d_value(1))
+      IF( il_ind /= 0 )THEN
+         il_area = INT(td_file%t_att(il_ind)%d_value(1))
       ENDIF
 
       ! get domain global size
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_size_global" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_size_global" )
       il_iglo = 0
       il_jglo = 0
-      IF( il_attid /= 0 )THEN
-         il_iglo = INT(td_file%t_att(il_attid)%d_value(1))
-         il_jglo = INT(td_file%t_att(il_attid)%d_value(2))
+      IF( il_ind /= 0 )THEN
+         il_iglo = INT(td_file%t_att(il_ind)%d_value(1))
+         il_jglo = INT(td_file%t_att(il_ind)%d_value(2))
       ENDIF
 
@@ -1600,19 +1525,19 @@
       ! allocate local variable
       ALLOCATE( il_impp(il_nproc), il_jmpp(il_nproc),&
-      &         il_lci(il_niproc),  il_lcj(il_njproc), &
-      &         il_ldi(il_niproc),  il_ldj(il_njproc), &
-      &         il_lei(il_niproc),  il_lej(il_njproc) )
+      &         il_lci(il_nproc),  il_lcj(il_nproc), &
+      &         il_ldi(il_nproc),  il_ldj(il_nproc), &
+      &         il_lei(il_nproc),  il_lej(il_nproc) )
 
       ! get domain first poistion
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_I_position_first" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_I_position_first" )
       il_impp(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_impp(:) = INT(td_file%t_att(il_attid)%d_value(:))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_J_position_first" )
+      IF( il_ind /= 0 )THEN
+         il_impp(:) = INT(td_file%t_att(il_ind)%d_value(:))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_J_position_first" )
       il_jmpp(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_jmpp(:) = INT(td_file%t_att(il_attid)%d_value(:))
+      IF( il_ind /= 0 )THEN
+         il_jmpp(:) = INT(td_file%t_att(il_ind)%d_value(:))
       ENDIF
       
@@ -1623,14 +1548,14 @@
 
       ! get domain last poistion
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_I_position_last" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_I_position_last" )
       il_lci(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_lci(:) = INT(td_file%t_att(il_attid)%d_value(:))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_J_position_last" )
+      IF( il_ind /= 0 )THEN
+         il_lci(:) = INT(td_file%t_att(il_ind)%d_value(:))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_J_position_last" )
       il_lcj(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_lcj(:) = INT(td_file%t_att(il_attid)%d_value(:))
+      IF( il_ind /= 0 )THEN
+         il_lcj(:) = INT(td_file%t_att(il_ind)%d_value(:))
       ENDIF
 
@@ -1641,14 +1566,14 @@
 
       ! get halo size start
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_I_halo_size_start" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_I_halo_size_start" )
       il_ldi(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_ldi(:) = INT(td_file%t_att(il_attid)%d_value(:))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_J_halo_size_start" )
+      IF( il_ind /= 0 )THEN
+         il_ldi(:) = INT(td_file%t_att(il_ind)%d_value(:))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_J_halo_size_start" )
       il_ldj(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_ldj(:) = INT(td_file%t_att(il_attid)%d_value(:))
+      IF( il_ind /= 0 )THEN
+         il_ldj(:) = INT(td_file%t_att(il_ind)%d_value(:))
       ENDIF
       
@@ -1659,14 +1584,14 @@
 
       ! get halo size end
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_I_halo_size_end" )
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_I_halo_size_end" )
       il_lei(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_lei(:) = INT(td_file%t_att(il_attid)%d_value(:))
-      ENDIF
-
-      il_attid=att_get_id( td_file%t_att, "DOMAIN_J_halo_size_end" )
+      IF( il_ind /= 0 )THEN
+         il_lei(:) = INT(td_file%t_att(il_ind)%d_value(:))
+      ENDIF
+
+      il_ind=att_get_index( td_file%t_att, "DOMAIN_J_halo_size_end" )
       il_lej(:) = 0
-      IF( il_attid /= 0 )THEN
-         il_lej(:) = INT(td_file%t_att(il_attid)%d_value(:))
+      IF( il_ind /= 0 )THEN
+         il_lej(:) = INT(td_file%t_att(il_ind)%d_value(:))
       ENDIF
 
@@ -1690,8 +1615,8 @@
       &  il_area,                &
       &  il_iglo, il_jglo,       &
-      &  il_impp(:), il_jmpp(:), &
       &  il_lci(:), il_lcj(:),   &
       &  il_ldi(:), il_ldj(:),   &
-      &  il_lei(:), il_lej(:)
+      &  il_lei(:), il_lej(:),   &
+      &  il_impp(:), il_jmpp(:)
 
       DEALLOCATE( il_impp, il_jmpp,&
@@ -1701,14 +1626,12 @@
 
       END SUBROUTINE iom_rstdimg__write_header
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine write variables in an opened dimg file.</br/>
-   !
+   !-------------------------------------------------------------------
+   !> @brief This subroutine write variables in an opened dimg file.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] id_fileid : file id
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] id_fileid file id
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__write_var(td_file)
       IMPLICIT NONE
